Package: DCATS
Type: Package
Title: Differential Composition Analysis Transformed by a Similarity
        matrix
Version: 1.8.0
Authors@R: c(
    person("Xinyi", "Lin", , "linxy29@connect.hku.hk", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-7780-2461")),
    person("Chuen", "Chau", email = "hadley@posit.co", role = "aut"),
    person("Yuanhua", "Huang", email = "jenny@posit.co", role = "aut"),
    person("Joshua W.K. Ho", role = "aut"))
Description: Methods to detect the differential composition abundances between 
    conditions in singel-cell RNA-seq experiments, with or without replicates. 
    It aims to correct bias introduced by missclaisification and enable 
    controlling of confounding covariates. To avoid the influence of proportion 
    change from big cell types, DCATS can use either total cell number or 
    specific reference group as normalization term.
Depends: R (>= 4.1.0), stats
License: MIT + file LICENSE
Imports: MCMCpack, matrixStats, robustbase, aod, e1071
Suggests: testthat (>= 3.0.0), knitr, Seurat, SeuratObject, tidyverse,
        rmarkdown, BiocStyle
VignetteBuilder: knitr
RoxygenNote: 7.2.3
biocViews: SingleCell, Normalization
Encoding: UTF-8
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/DCATS
git_branch: RELEASE_3_22
git_last_commit: ed0c9f6
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 03:28:45 UTC; biocbuild
Author: Xinyi Lin [aut, cre] (ORCID: <https://orcid.org/0000-0002-7780-2461>),
  Chuen Chau [aut],
  Yuanhua Huang [aut],
  Joshua W.K. Ho [aut]
Maintainer: Xinyi Lin <linxy29@connect.hku.hk>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# DCATS

<!-- badges: start -->
<!-- badges: end -->

This R package contains methods to detect the differential composition
abundances between multiple conditions in singel-cell experiments.

The **latest** version of the `DCATS` package is 0.99.7. It is under the
MIT license.

## Installation

### From R

The **latest** `DCATS` package can be conveniently installed using the
[`devtools`](https://www.rstudio.com/products/rpackages/devtools/)
package thus:

``` r
## install dependencies
install.packages(c("MCMCpack", "matrixStats", "robustbase", "aod", "e1071"))
## dependencies for vignette
install.packages(c("SeuratObject", "Seurat", "robustbase", "aod", "e1071"))
devtools::install_github('satijalab/seurat-data')
```

``` r
# install.packages("devtools")
devtools::install_github("holab-hku/DCATS", build_vignettes = TRUE)
```

You can also install `DCATS` without building the vignette:

    devtools::install_github("holab-hku/DCATS")

### From Biocounductor (required R &gt;= 4.3.0)

``` r
if (!requireNamespace("BiocManager"))
install.packages("BiocManager")
BiocManager::install("DCTAS")
```

#### For development

Download this repository to your local machine and open it in Rstudio as
a project, and build it by install and restart.

## Getting started

The best place to start are the vignettes. Inside an R session, load
`DCATS` and then browse the vignette about the usage guidance of
`DCATS`:

``` r
library(DCATS)
browseVignettes("DCATS")
```

The tutorial demonstrating how to use DCATS after using
[`Seurat`](https://satijalab.org/seurat/index.html) pipeline to process
data can be found in
[`Integrate DCATS with Seurat pipeline`](https://htmlpreview.github.io/?https://github.com/linxy29/DCATS_anlysis/blob/master/vignette/Integrate_with_seurat.html).

### Example

This is a basic example which shows you how to estimate a similarity
matrix from KNN graph and do the differential abundance test using this
similarity matrix.

``` r
library(DCATS)
data("simulation")
knn_mat = knn_simMat(simulation$knnGraphs, simulation$labels)
sim_count = rbind(simulation$numb_cond1, simulation$numb_cond2)
sim_design = data.frame(condition = c("c1", "c1", "c2"))
knn_mat[colnames(sim_count),]
res = dcats_GLM(as.matrix(sim_count), sim_design, similarity_mat = knn_mat)
print(res$LRT_pvals)
```

#' Calculate a global phi for all cell types
#'
#' Assuming all cell types share the same phi. This global phi can be calculate 
#' by pooling all cell types together to fit a beta binomial distribution.
#'
#' @param count_mat A matrix of composition sizes (n_sample, n_cluster) for each
#'   cluster in each sample
#' @param design_mat A matrix of testing candidate factors (n_sample, n_factor)
#'   with same sample order as count_mat
#'   
#' @return A number indicating a global phi for all cell types
#'   
#' @export
#'
#' @examples
#' K <- 3
#' totals1 = c(100, 800, 1300, 600)
#' totals2 = c(250, 700, 1100)
#' diri_s1 = rep(1, K) * 20
#' diri_s2 = rep(1, K) * 20
#' simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
#' sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
#' sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
#' sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"))
#' phi = DCATS::getPhi(sim_count, sim_design)


getPhi <- function(count_mat, design_mat){
  K <- ncol(count_mat)
  S <- nrow(count_mat)
  total <- rep(rowSums(count_mat), K)
  n1 <- matrix(count_mat, ncol = 1)
  design_use <- do.call("rbind", replicate(K, design_mat, simplify = FALSE))
  celltype_idx <- matrix(0, S*K, K)
  for (type in seq(1,K)) {
    celltype_idx[(seq(1,S))+S*(type-1),type] <- 1
  }
  df_use <- data.frame(total, n1, design_use, celltype_idx[,-1])
  fm <- aod::betabin(cbind(n1, total-n1) ~ ., ~ 1, data = df_use, warnings = FALSE) # make intercept as 0
  return(fm@random.param)
}

library(testthat)
library(DCATS)

test_that("whether simulator works", {
  K <- 2
  totals1 = c(100, 800, 1300, 600)
  totals2 = c(250, 700, 1100)
  diri_s1 = diri_s2 = rep(1, K) * 20
  simil_mat = create_simMat(K, 0.2)
  sim_dat <- simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
  
  expect_equal(dim(sim_dat$numb_cond1)[2], K)
  expect_equal(dim(sim_dat$numb_cond2)[2], K)
  expect_equal(rowSums(sim_dat$numb_cond1), totals1)
  expect_equal(rowSums(sim_dat$numb_cond2), totals2)
})

test_that("whether EM process works", {
  X = c(100, 300, 1500, 500, 1000)
  simMM = create_simMat(5, confuse_rate=0.2)
  res = multinom_EM(X, simMM)
  
  expect_equal(sum(res$mu), 1)
})

test_that("whether phi estimation works", {
  set.seed(123)
  K <- 3
  totals1 = c(100, 800, 1300, 600)
  totals2 = c(250, 700, 1100)
  diri_s1 = rep(1, K) * 20
  diri_s2 = rep(1, K) * 20
  simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
  sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
  sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
  sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"))
  phi = DCATS::getPhi(sim_count, sim_design)
  
  expect_equal(as.numeric(round(phi, 6)) < 0.01, TRUE)
})

#' Calculate stochastic transition matrix between clusters from a KNN connection
#' matrix
#'
#' The transition probability from cluster i to j is the fraction of neighbours
#' of all samples in cluster i that belongs to cluster j. Note, this matrix is
#' asymmetric, so as the input KNN connection matrix.
#'
#' @param KNN_matrix a sparse binary matrix with size (n_sample, n_sample).
#'   x_ij=1 means sample j is a neighbour of sample i. As definition, we expect
#'   sum(KNN_matrix) = n_sample * K, where K is the number neighbours.
#' @param clusters a (n_sample, ) vector of cluster id for each sample.
#' 
#' @export
#'
#' @examples
#' data(simulation)
#' knn_mat = knn_simMat(simulation$knnGraphs, simulation$labels)
#' 
#' @return a similarity matrix calculated based on the knn graph.

knn_simMat <- function(KNN_matrix, clusters){
    clusters_uniq <- unique(clusters)
    n_cluster <- length(clusters_uniq)

    simi_mat <- matrix(0, n_cluster, n_cluster)
    rownames(simi_mat) <- colnames(simi_mat) <- clusters_uniq
    for (i in seq_len(n_cluster)) {
        idx_i <- clusters == clusters_uniq[i]
        for (j in seq_len(n_cluster)) {
            idx_j <- clusters == clusters_uniq[j]
            simi_mat[i, j] <- sum(KNN_matrix[idx_i, ][, idx_j])
        }
    }
    simi_mat / rowSums(simi_mat)
}

#' An EM algorithm to fit a multinomial with maximum likelihood
#'
#' @param X A vector of commopent sizes
#' @param simMM A matrix of floats (n_cluster, n_cluster) for the similarity
#'   matrix between clusters. simMM[i,j] means the proportion of cluster i will
#'   be assigned to cluster j, hence colSums(simMM) are ones.
#' @param max_iter integer(1). number of maximum iterations
#' @param min_iter integer(1). number of minimum iterations
#' @param logLik_threshold A float. The threshold of logLikelihood increase for
#'   detecting convergence
#'
#' @return a list containing \code{mu}, a vector for estimated latent proportion
#'   of each cluster, \code{logLik}, a float for the estimated log likelihood,
#'   \code{simMM}, the input of simMM, code{X}, the input of X, \code{X_prop},
#'   the proportion of clusters in the input X, \code{predict_X_prop}, and the
#'   predicted proportion of clusters based on mu and simMM.
#'
#' @export
#'
#' @examples
#' X = c(100, 300, 1500, 500, 1000)
#' simMM = create_simMat(5, confuse_rate=0.2)
#' multinom_EM(X, simMM)
#' 
multinom_EM <- function(X, simMM, min_iter=10, max_iter=1000, logLik_threshold=1e-2) {
    # Be very careful on the shape of simMM; rowSums(simMM) = 1
    K <- ncol(simMM)

    # initialization
    mu <- sample(K)
    mu <- mu / sum(mu)
    Z <- matrix(NA, K, K)
    logLik_old <- logLik_new <- log(mu %*% simMM) %*% X

    for (it in seq_len(max_iter)) {
        ## E step: expectation of count from each component

        for (i in seq(K)) {
            for (j in seq(K)){
                Z[i, j] <- simMM[i, j] * mu[i] / sum(mu * simMM[, j])
            }
        }

        ## M step: maximizing likelihood

        ## v2
        mu <- c(Z %*% X)
        mu <- mu / sum(mu)

        ## Check convergence
        logLik_new <- log(mu %*% simMM) %*% X
        if (it > min_iter && logLik_new - logLik_old < logLik_threshold) {
            break
        } else {
            logLik_old <- logLik_new
        }

    }

    ## return values
    list("mu" = mu, "logLik" = logLik_new, "simMM" = simMM, "X" = X, 
         "X_prop" = X / sum(X), "predict_X_prop" = mu %*% simMM)
}

# matrix(seq(6), 2, 3) * c(1, 2)

#' A Generalised linear model based likelihood ratio testing
#'
#' GLM supports both beta-binomial and negative binomial from aod package.
#'
#' @param count_mat A matrix of composition sizes (n_sample, n_cluster) for each
#'   cluster in each sample
#' @param design_mat A matrix or a data frame of testing candidate factors 
#'   (n_sample, n_factor) with same sample order as count_mat. All factors 
#'   should be continous and categorical with only two levels. 
#' @param similarity_mat A matrix of floats (n_cluster, n_cluster) for the
#'   similarity matrix between cluster group pair. The order of cluster should
#'   be consistent with those in `count_mat`.
#' @param pseudo_count A pseudo count to add for counts in all cell types
#'   Default NULL means 0 except if a cell type is empty in one condition,
#'   otherwise pseudo_count will be: 0.01 * rowMeans for each condition
#' @param base_model A string value: `NULL` for 1 factor vs NULL factor testing;
#'   `FULL` for FULL factors vs n-1 factors testing.
#' @param fix_phi A numeric used to provided a fixed phi value for the GLM 
#'   for all cell types
#' @param reference A vector of characters indicating which cell types are used 
#' as reference for normalization. `NULL` indicates using total count for 
#' normalization.
#'
#' @return a list of significance p values for each cluster
#'
#' @export
#' @importFrom matrixStats colSds
#' @import stats
#'
#' @examples
#' K <- 3
#' totals1 = c(100, 800, 1300, 600)
#' totals2 = c(250, 700, 1100)
#' diri_s1 = rep(1, K) * 20
#' diri_s2 = rep(1, K) * 20
#' simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
#' sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
#' sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
#' sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"), 
#' gender = sample(c("Female", "Male"), 7, replace = TRUE))
#' ## Using 1 factor vs NULL factor testing
#' dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat)
#' ## Using full factors vs n-1 factors testing with intercept term
#' dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, base_model='FULL')
#' ## Fix phi
#' dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, fix_phi = 1/61)
#' ## Specify reference cell type
#' colnames(sim_count) <- c("celltypeA", "celltypeB", "celltypeC")
#' 

dcats_GLM <- function (count_mat, design_mat, similarity_mat = NULL, pseudo_count = NULL, 
                       base_model = "NULL", fix_phi = NULL, reference = NULL) 
{
  coeffs <- matrix(NA, ncol(count_mat), ncol(design_mat))
  coeffs_err <- matrix(NA, ncol(count_mat), ncol(design_mat))
  LR_vals <- matrix(NA, ncol(count_mat), ncol(design_mat))
  LRT_pvals <- matrix(NA, ncol(count_mat), ncol(design_mat))
  pvals <- matrix(NA, ncol(count_mat), ncol(design_mat))
  LRT_fdr <- matrix(NA, ncol(count_mat), ncol(design_mat))
  if (is.null(colnames(count_mat))) 
    colnames(count_mat) <- paste0("cell_type_", seq(ncol(count_mat)))
  if (is.null(colnames(design_mat))) 
    colnames(design_mat) <- paste0("factor_", seq(ncol(design_mat)))
  rownames(LR_vals) <- rownames(LRT_pvals) <- rownames(pvals) <- rownames(LRT_fdr) <- rownames(coeffs) <- rownames(coeffs_err) <- colnames(count_mat)
  colnames(LR_vals) <- colnames(LRT_pvals) <- colnames(pvals) <- colnames(LRT_fdr) <- colnames(coeffs) <- colnames(coeffs_err) <- colnames(design_mat)
  count_use <- count_mat
  if (!is.null(similarity_mat)) {
    for (i in seq_len(nrow(count_mat))) {
      count_use[i, ] <- sum(count_mat[i, ]) * multinom_EM(count_mat[i, 
      ], similarity_mat)$mu
    }
  }
  K <- ncol(count_mat)
  if (is.null(pseudo_count)) {
    if (any(colMeans(count_mat) == 0)) {
      warning("Empty cell type exists in at least one conidtion; adding replicate & condition specific pseudo count:")
      count_use <- count_use + 1
    }
  }
  else {
    count_use <- count_use + pseudo_count
  }
  count_use <- round(count_use)
  n_samples <- 1
  for (k in seq_len(ncol(design_mat))) {
    sub_LR_val <- matrix(NA, n_samples, K)
    sub_coeffs_val <- matrix(NA, n_samples, K)
    sub_coeffs_err <- matrix(NA, n_samples, K)
    for (ir in seq_len(n_samples)) {
      idx <- seq(1, nrow(count_use), n_samples) + ir - 1
      for (m in seq_len(ncol(count_use))) {
        if (is.null(reference)) {
          df_use <- data.frame(n1 = count_use[, m], total = rowSums(count_use))[idx, 
          ]
          df_use$ref_count <- df_use$total - df_use$n1
        }
        else {
          if (length(reference) == 1) {df_use <- data.frame(n1 = count_use[, m], ref_count = count_use[, 
                                                                                                       reference])[idx, ]} else {df_use <- data.frame(n1 = count_use[, m], ref_count = rowSums(count_use[, 
                                                                                                                                                                                                         reference]))[idx, ]}
        }
        df_use <- cbind(df_use, design_mat)
        df_tmp <- df_use[!is.na(design_mat[, k]), ]
        if (base_model == "NULL" | ncol(design_mat) == 
            1) {
          formula_fm0 <- as.formula("cbind(n1, ref_count) ~ 1")
          formula_fm1 <- as.formula(paste0("cbind(n1, ref_count)", 
                                           "~ 1+", colnames(design_mat)[k], sep = ""))
        }
        else if (base_model == "FULL") {
          fm0_right <- paste(colnames(design_mat)[-k], 
                             collapse = " + ")
          fm1_right <- paste(colnames(design_mat), collapse = " + ")
          formula_fm0 <- as.formula(paste0("cbind(n1, ref_count)", 
                                           " ~ 1 + ", fm0_right, sep = ""))
          formula_fm1 <- as.formula(paste0("cbind(n1, ref_count)", 
                                           " ~ 1 + ", fm1_right, sep = ""))
        }
        fm0 <- aod::betabin(formula_fm0, ~1, data = df_tmp, 
                            warnings = FALSE)
        fm1 <- aod::betabin(formula_fm1, ~1, data = df_tmp, 
                            warnings = FALSE)
        if (!is.null(fix_phi)) {
          fm0 <- aod::betabin(formula_fm0, ~1, data = df_tmp, 
                              warnings = FALSE, fixpar = list(fm0@nbpar, 
                                                              fix_phi))
          fm1 <- aod::betabin(formula_fm1, ~1, data = df_tmp, 
                              warnings = FALSE, fixpar = list(fm1@nbpar, 
                                                              fix_phi))
        }
        if (length(fm1@varparam) < 4 || is.na(fm1@varparam[2, 
                                                           2])) {
          next
        }
        sub_LR_val[ir, m] <- fm0@dev - fm1@dev
        parID <- grep(colnames(design_mat)[k], names(fm1@param))
        if (length(parID) > 1) 
          stop("Please check the design matrix, make sure all factors are continous or categorical with only two levels.")
        sub_coeffs_val[ir, m] <- fm1@param[parID]
        if (is.null(fix_phi)) 
          sub_coeffs_err[ir, m] <- fm1@varparam[parID, 
                                                parID]
      }
    }
    coeff_val_mean <- colMeans(sub_coeffs_val, na.rm = TRUE)
    if (is.null(fix_phi)) {
      if (is.null(n_samples) || is.null(similarity_mat) || 
          n_samples == 1) {
        sub_coeff_err_pool <- colMeans(sub_coeffs_err^2, 
                                       na.rm = TRUE)
      }
      else {
        sub_coeff_err_pool <- colMeans(sub_coeffs_err^2, 
                                       na.rm = TRUE) + matrixStats::colSds(sub_coeffs_val) + 
          matrixStats::colSds(sub_coeffs_val)/n_samples
      }
      pvals[, k] <- pnorm(-abs(coeff_val_mean)/sqrt(sub_coeff_err_pool)) * 
        2
      coeffs_err[, k] <- sqrt(sub_coeff_err_pool)
    }
    LR_median <- robustbase::colMedians(sub_LR_val, na.rm = TRUE)
    LR_vals[, k] <- LR_median
    LRT_pvals[, k] <- pchisq(LR_median, df = 1, lower.tail = FALSE, 
                             log.p = FALSE)
    coeffs[, k] <- coeff_val_mean
  }
  LRT_fdr[, ] <- p.adjust(LRT_pvals, method = "fdr")
  res <- list(ceoffs = coeffs, coeffs_err = coeffs_err, LR_vals = LR_vals, 
              LRT_pvals = LRT_pvals, fdr = LRT_fdr)
  res
}

library(testthat)
library(DCATS)

test_that("whether dcats_GLM works as we expected", {
  set.seed(3)
  K <- 3
  totals1 = rep(300, 4)
  totals2 = rep(300, 3)
  diri_s1 = rep(1/K, K) * 200
  diri_s2 = c(1/3, 1/2, 1/6) * 200
  simil_mat = create_simMat(K, confuse_rate=0.1)
  sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
  sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
  sim_design = matrix(c("g1", "g1", "g1", "g1", "g2", "g2", "g2"), ncol = 1)
  res = dcats_GLM(sim_count, sim_design)

  expect_equal(as.vector(res$LRT_pvals) > 0.05, c(TRUE, FALSE, FALSE))

})

#' Calculate stochastic transition matrix between clusters from a data frame 
#' including information about clustering
#'
#' The transition probability from cluster i to j is calculated based on the 
#' information used to cluster cells. It is estimated by the misclassification 
#' rate from cluster i to j comparing the original labels with the labels predicted 
#' by support vector machine with 5-fold cross validation.
#'
#' @param dataframe a data frame contains the information used for clustering 
#' and the original label of each cell. The original labels should have the 
#' column name `clusterRes`.
#' 
#' @export
#' @examples
#' data(Kang2017)
#' svm_mat = svm_simMat(Kang2017$svmDF)
#'
#' @return a similarity matrix estimated by 5-fold cross validation support 
#' vector machine.

svm_simMat <- function(dataframe){
  dataframe$clusterRes <- as.factor(dataframe$clusterRes)
  row_num <- nrow(dataframe)
  pred <- rep(NA, row_num)
  idx1 <- sample(seq(1,row_num), round(row_num/5))
  idx2 <- sample(seq(1,row_num)[-idx1], round(row_num/5))
  idx3 <- sample(seq(1,row_num)[-c(idx1, idx2)], round(row_num/5))
  idx4 <- sample(seq(1,row_num)[-c(idx1, idx2, idx3)], round(row_num/5))
  idx5 <- seq(1,row_num)[-c(idx1, idx2, idx3, idx4)]
  idxV <- list(idx1, idx2, idx3, idx4, idx5)
  for (i in seq(1,5)){
    svmfit <- e1071::svm(as.formula("clusterRes ~ ."), data = dataframe[-idxV[[i]],], kernel = "radial")
    pred[idxV[[i]]] <- as.character(aod::predict(svmfit, subset(dataframe, select = -clusterRes)[idxV[[i]],]))
  }
  conf.mat <- table(dataframe$clusterRes, as.factor(pred))
  simil_mat <- t(t(conf.mat)/apply(conf.mat,2,sum))
  return(simil_mat)
}

#' Calculate a global phi for all cell types
#'
#' Assuming all cell types share the same phi. This global phi can be calculate 
#' by pooling all cell types together to fit a beta binomial distribution.
#'
#' @param count_mat A matrix of composition sizes (n_sample, n_cluster) for each
#'   cluster in each sample.
#' @param design_mat A matrix or a data frame of testing candidate factors 
#'   (n_sample, n_factor) with same sample order as count_mat. All factors 
#'   should be continous and categorical with only two levels. 
#' @param similarity_mat A matrix of floats (n_cluster, n_cluster) for the
#'   similarity matrix between cluster group pair. The order of cluster should
#'   be consistent with those in `count_mat`.
#' @param fix_phi A numeric used to provided a fixed phi value for the GLM 
#'   for all cell types.
#'   
#' @return A data frame with ordered cell types and their p-value. Cell types 
#' are ordered by their p-values. The order indicating how they are recommended
#' to be selected as reference cell types.
#' 
#'   
#' @export
#' 
#' @examples
#' K <- 3
#' totals1 = c(100, 800, 1300, 600)
#' totals2 = c(250, 700, 1100)
#' diri_s1 = rep(1, K) * 20
#' diri_s2 = rep(1, K) * 20
#' simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
#' sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
#' sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
#' sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"), 
#' gender = sample(c("Female", "Male"), 7, replace = TRUE))
#' ## Using 1 factor vs NULL factor testing
#' detect_reference(sim_count, sim_design)

detect_reference <- function(count_mat, design_mat, similarity_mat = NULL, fix_phi = NULL){
  res <- dcats_GLM(count_mat, design_mat, similarity_mat, fix_phi = fix_phi)
  resDF <- data.frame(celltype = rownames(res$LRT_pval), pval = as.vector(apply(res$LRT_pvals, 1, min)))
  resDF <- resDF[resDF$pval > 0.1,]
  resDF <- resDF[order(-resDF$pval),]
  if (nrow(resDF) < 2)
    return("No suitable reference cell type detected.")
  ## calculate reference group proportion
  if (is.null(colnames(count_mat))) 
    colnames(count_mat) <- paste0("cell_type_", seq(ncol(count_mat)))
  typeSum <- colSums(count_mat)
  for (celltype_num in seq(2,nrow(resDF))) {
    if (sum(typeSum[resDF$celltype[seq(1,celltype_num)]])/sum(typeSum) > 0.25) {
      message("Please check the 'min_celltypeN' for the number of minimum cell types recommend.")
      res <- list(min_celltypeN = celltype_num, ordered_celltype = resDF$celltype)
      return(res)
    }
  }
}

#' Composition size simulator
#'
#' Directly simulating the composition size from a Dirichlet-Multinomial
#' distribution with replicates for two conditions.
#'
#' @param totals_cond1 A vector of integers (n_rep1, ) for the total samples in
#'   each replicate in codition 1
#' @param totals_cond2 A vector of integers (n_rep2, ) for the total samples in
#'   each replicate in codition 2
#' @param dirichlet_s1 A vector of floats (n_cluster, ) for the composition
#'   concentration in condition 1
#' @param dirichlet_s2 A vector of floats (n_cluster, ) for the composition
#'   concentration in condition 2
#' @param similarity_mat A matrix of floats (n_cluster, n_cluster) for the
#'   similarity matrix between each cluster pair
#'
#' @return a list of two matrices for composition sizes in each replicate and
#'   each cluster in both conditions.
#'
#' @export
#' @importFrom MCMCpack rdirichlet
#'
#'
#' @examples
#' K <- 2
#' totals1 = c(100, 800, 1300, 600)
#' totals2 = c(250, 700, 1100)
#' diri_s1 = rep(1, K) * 20
#' diri_s2 = rep(1, K) * 20
#' confuse_rate = 0.2
#' simil_mat = create_simMat(2, 0.2)
#' sim_dat <- simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
#' 
simulator_base <- function(totals_cond1, totals_cond2,
                           dirichlet_s1, dirichlet_s2,
                           similarity_mat=NULL) {
    K <- length(dirichlet_s1)       # number of clusters
    n_rep1 <- length(totals_cond1)  # number of replicates in condition 1
    n_rep2 <- length(totals_cond2)  # number of replicates in condition 2

    prop_cond1 <- matrix(0, n_rep1, K)
    prop_cond2 <- matrix(0, n_rep2, K)
    numb_cond1 <- matrix(0, n_rep1, K)
    numb_cond2 <- matrix(0, n_rep2, K)
    for (i in seq_len(n_rep1)) {
        prop_cond1[i, ] <- MCMCpack::rdirichlet(1, dirichlet_s1)
        numb_cond1[i, ] <- rmultinom(1, totals_cond1[i], prop_cond1[i, ])
    }
    for (i in seq_len(n_rep2)) {
        prop_cond2[i, ] <- MCMCpack::rdirichlet(1, dirichlet_s2)
        numb_cond2[i, ] <- rmultinom(1, totals_cond2[i], prop_cond2[i, ])
    }

    if (is.null(similarity_mat)) {
        similarity_mat <- diag(K)
    }

    ## sampling based on similarity matrix
    numb_out_cond1 <- matrix(0, n_rep1, K)
    numb_out_cond2 <- matrix(0, n_rep2, K)
    for (i in seq_len(n_rep1)) {
        for (j in seq_len(K)) {
            numb_out_cond1[i, ] <- (numb_out_cond1[i, ] +
                                        rmultinom(1, numb_cond1[i, j],
                                                  similarity_mat[j, ])[, 1])
        }
    }

    for (i in seq_len(n_rep2)) {
        for (j in seq_len(K)) {
            numb_out_cond2[i, ] <- (numb_out_cond2[i, ] +
                                        rmultinom(1, numb_cond2[i, j],
                                                  similarity_mat[j, ])[, 1])
        }
    }

    list("numb_cond1" = numb_out_cond1,
         "numb_cond2" = numb_out_cond2,
         "true_cond1" = numb_cond1,
         "true_cond2" = numb_cond2)
}

#' Count matrices of intestinal epithelial scRNA-seq data from three conditions
#'
#' A data containing the count matrices, the similarity matrix and other 
#' variables used to generate the similarity matrix from intestinal epithelial 
#' single cell RNA sequencing data with three condition. Count matrices are 
#' calculated based on the number of cells in each cell type. The similarity 
#' matrix is calculated by support vector machine classifiers using 5-fold 
#' cross validation. Top 30 PCs are used as predictors.
#'
#' @format A list with 7 items:
#' \describe{
#'   \item{count_ctrl}{the count matrix for the control group}
#'   \item{count_Hpoly3}{the count matrix for three days after H.polygyrus infection}
#'   \item{count_Hpoly10}{the count matrix for ten days after H.polygyrus infection}
#'   \item{count_Salma}{the count matrix for two days after Salmonella infection}
#'   \item{svm_mat}{the similarity matrix}
#'   \item{source}{the source of this dataset}
#' }
#' @source \url{https://www.nature.com/articles/nature24489}
#' @examples 
#' library(DCATS)
#' data(Haber2017)
"Haber2017"

#' Count matrices of 8 pooled lupus patient samples within two conditions
#'
#' A data containing the count matrices, the similarity matrix and other 
#' variables used to generate the similarity matrix 
#' from single cell RNA sequencing data of 8 pooled lupus patient samples within 
#' two conditions. Count matrices are 
#' calculated based on the number of cells in each cell type. The similarity 
#' matrix is calculated by support vector machine classifiers using 5-fold 
#' cross validation. Top 30 PCs are used as predictors. The svmDF contains 30 
#' PCs generated by standard Seurat pipeline and the condition, cell type 
#' information collected from the original paper.
#'
#' @format A list with 5 items:
#' \describe{
#'   \item{count_ctrl}{the count matrix for three days after H.polygyrus infection}
#'   \item{count_stim}{the count matrix for ten days after H.polygyrus infection}
#'   \item{svm_mat}{the simularity matrix}
#'   \item{svmDF}{the data frame used to calculate the similarity matrix.}
#'   \item{source}{the source of this dataset}
#' }
#' @source \url{https://www.nature.com/articles/nbt.4042}
"Kang2017"

#' Count matrix and metadata of a large COVID-19 scRNA-seq data cohort.
#'
#' A data containing the count matrix, metadata from a large COVID-19 cohort.
#' Count matrices are 
#' calculated based on the number of cells in each cell type. The information 
#' in the design matrix is collected in the original paper.
#'
#' @format A list with 7 items:
#' \describe{
#'   \item{countM}{the count matrix for all samples comming from different condition}
#'   \item{designM}{the corresponding metadata related to each sample}
#'   \item{source}{the source of this dataset}
#' }
#' @source \url{https://www.nature.com/articles/nature24489}
"Ren2021"

#' Simulated dataset with two conditions
#'
#' A data containing the count matrices, the similarity matrix and other 
#' variables used to generate the similarity matrix 
#' from a simulated single cell RNA sequencing data with two conditions. 
#' Dirichlet distribution was used to generate a proportion vector for cell 
#' types based on the defined true proportions. Multinomial distribution was 
#' used to generate simulated cell numbers. Cells were selected from cell pools
#' based on cell numbers and gene expression matrices were processed by Seurat.
#' The count matrix were calculated by the clustering results, and the 
#' similarity matrix was calculated using knn graph. The labels are the groud
#' true annotation of each cell.
#'
#' @format A list with 5 items:
#' \describe{
#'   \item{numb_cond1}{the count matrix of condition 1}
#'   \item{numb_cond2}{the count matrix of condition 2}
#'   \item{knn_mat}{the similariy matrix}
#'   \item{knnGraphs}{the knn graphs information used to calculate the 
#'   similarity matrix.}
#'   \item{labels}{the clusters' label for each simulated single cell}
#' }
"simulation"

#' Generate similarity matrix with uniform confusion rate to none-self clusters
#'
#' Create a similarity matrix assuming the misclassification error distribute
#' uniformly in all clusters
#'
#' @param K A integer for number of cluster
#' @param confuse_rate A float for confusion rate, uniformly to none-self
#'   clusters
#'
#' @return a similarity matrix with uniform confusion with other cluster
#'
#' @export
#'
#' @examples
#' create_simMat(4, 0.1)
#' 

create_simMat <- function(K, confuse_rate) {
  diag(K) * (1 - confuse_rate) + confuse_rate * (1 - diag(K)) / (K - 1)
}

library(testthat)
library(DCATS)

test_that("create_simMat generate a matrix we want", {
  stdRes = matrix(c(0.9, rep(0.1/3, 4), 0.9, rep(0.1/3, 4), 0.9, rep(0.1/3, 4), 0.9), ncol = 4)
  
  expect_equal(create_simMat(4, 0.1), stdRes)
  
})


#> Test passed 🌈

---
title: "Differential Composition Analysis with DCATS"
author: "Xinyi LIN"
date: "`r Sys.Date()`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Differential Composition Analysis with DCATS}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
library(BiocStyle)
```

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction

Single-cell RNA sequencing (scRNA-seq) has been widely used to deepen our 
understanding of various biological processes, including cell differentiation, 
tumor development and disease occurrence. However, it remains challenging to 
effectively detect differential compositions of cell types when comparing 
samples coming from different conditions or along with continuous covariates, 
partly due to the small number of replicates and high uncertainty of cell 
clustering.

This vignette provides an introduction to the `DCATS` package, which contains 
methods to detect the differential composition abundances between multiple 
conditions in singel-cell experiments. It can be easily incooperated with 
existing single cell data analysis pipeline and contribute to the whole 
analysis process.

# Installation
To install `DCATS`, first make sure that you have the devtools package installed:

```r
if (!requireNamespace("devtools", quietly = TRUE))
  install.packages("BiocManager")
```

Then, install `DCATS` using the following command:

```r
BiocManager::install("DCTAS")
```

# Usage
To use DCATS, start by loading the package:

```{r, warning=FALSE}
library(DCATS)
```

## Simulate Data

Here, we used a built-in simulator in `DCATS` to simulate the data for following analysis. We simulate count data for four samples coming from the first condition with total cell counts 100, 800, 1300, and 600. We simulate another three samples coming from the second condition with total cell counts 250, 700, 1100.

In this simulator function, a proportion of different cell types is simulate following [a dirichlet distribution](https://en.wikipedia.org/wiki/Dirichlet_distribution) decided by $\{p_i\} \times c$ where $\{p_i\}$ is the true proportion vector and $c$ is a concentration parameter indicating how far way the simulated proportion can be. The larger the $c$, the higher probability to simulate a proportion vector close to the true proportion. Then the cell counts are generated from the multinomial distribution with self-defined total cell counts and simulated proportions.

```{r}
set.seed(6171)
K <- 3
totals1 = c(100, 800, 1300, 600)
totals2 = c(250, 700, 1100)
diri_s1 = rep(1, K) * 20
diri_s2 = rep(1, K) * 20
simil_mat = create_simMat(K, confuse_rate=0.2)
sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
```

The output of `simulator_base` is the cell counts matrices of two conditions.

```{r}
print(sim_dat$numb_cond1)
print(sim_dat$numb_cond2)
```

## Esitimate the Simlarity Matrix

`DCATS` provides three methods to get the similarity matrix which indicates the misclassification rate between different cell types. Currently, `DCATS` provides three ways to estimate the similarity matrix.

The first one describes an unbiased misclassification across all the cell types. It means that one cell from a cell type have equal chance to be assigned to rest other cell types. When the numbers of biological replicates are the same in two conditions and are relatively large, other unbiased random error will contribute more to the difference between the observed proportions and the true proportions. In this case, using this uniform confusion matrix is a better choice.

We use the function `create_simMat` to create a similarity matrix describe above. We need to specify the number of cell types $K$ and the confuse rate which indicates the proportion of cells from one cell type being assigned to other cell types.

```{r}
simil_mat = create_simMat(K = 3, confuse_rate = 0.2)
print(simil_mat)
```

The second kind of confusion matrix is estimated from the knn matrix provided by [Seurat](https://satijalab.org/seurat/). It calculates the proportion of neighborhoods that are regarded as other cell types. In this case, DCATS corrects cell proportions mainly based on the information of similarity between different cell types and variety within each cell types.

The input of this function should be a 'Graph' class from [SeuratObject](https://cran.r-project.org/web/packages/SeuratObject/index.html) and a factor vector containing the cell type information of each cell. We can estimate the knn similarity matrix for the `simulation` dataset included in the `DCATS` package.

```{r}
data(simulation)
print(simulation$knnGraphs[1:10, 1:10])
head(simulation$labels, 10)
## estimate the knn matrix
knn_mat = knn_simMat(simulation$knnGraphs, simulation$labels)
print(knn_mat)
```

The third way to estimate a confusion matrix is to use a support vector machine classifier. The input for estimating the confusion matrix will be a data frame containing a set of variables that the user believe will influence the result of the clustering process as well as the cell type labels for each cell. We then use 5-fold cross validation and support vector machine as the classifier to predict cell type labels. By comparing given labels and predicted labels, we can get a confusion matrix.

**Noted**: Two packages `tidyverse` and `tidymodels` should be attached.

```{r}
data(Kang2017)
head(Kang2017$svmDF)
```

```{r, eval=FALSE}
library(tidyverse)
library(tidymodels)
## estimate the svm matrix
svm_mat = svm_simMat(Kang2017$svmDF)
print(svm_mat)
```

```{r, echo=FALSE}
print(Kang2017$svm_mat)
```

## Differential Abundance Anlysis

Here we used the simulated result to demonstrate the usage of `dcats_GLM`. We combine two cell counts matrices to create the count matrix, and create a corresponding data frame indicating the condition of those samples. `dcats_GLM` can give results based on the count matrix and design matrix.

**Noted** Even though we call it design matrix, we allow it to be both `matrix` and `data.frame`.

```{r, warning=FALSE}
sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
print(sim_count)
sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"))
print(sim_design)
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat)
```

The `ceoffs` indicates the estimated values of coefficients, the `coeffs_err` indicates the standard errors of coefficients, the `LRT_pvals` indicates the p-values calculated from the likelihood ratio test, and the `fdr` indicates the adjusted p-values given by [Benjamini & Hochberg method](https://www.jstor.org/stable/2346101?seq=1#metadata_info_tab_contents).

**Noted**: You might sometime receive a warning like `Possible convergence problem. Optimization process code: 10 (see ?optim).` It is caused by the low number of replicates and won't influence the final results.


## Other Models for Testing

When doing the differential abundance analysis in `DCATS`, we used generalized linear model assuming the cell counts follow beta-binomial distribution. `DCATS` provides p-values for each cluster considering each factor in the design matrix. The default model is comparing a model with only the tested factor and the null model. In this case, factors are tested independently.

We can also choose to compare the full model and a model without the tested factor. In this case, factors are tested when controlling the rest factors. 

```{r, warning=FALSE}
## add another factor for testing
set.seed(123)
sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"), 
                        gender = sample(c("Female", "Male"), 7, replace = TRUE))
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, base_model='FULL')
```

When fitting the beta binomial model, we have a parameter $\phi$ to describe the over-dispersion of data. The default setting of `DCATS` is to fit $\phi$ for each cell type. This might leads to over-fitting. Here we can use the `getPhi` function to estimate a global $\phi$ for all cell types and set `fixphi = TRUE` to apply this global $\phi$ to all cell types.

In this case, `coeffs_err` is not available.

```{r, warning=FALSE}
sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"))
phi = DCATS::getPhi(sim_count, sim_design)
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, fix_phi = phi)
```

The `LRT_pvals` can be used to define whether one cell type shows differential proportion among different conditions by setting threshold as 0.05 or 0.01.

## Use reference cell types as normalization term

DCATS also supports the use of known unchanged cell types as reference cell types. We recommend using 1) more than one cell type; 2) more than 20% of total cells as the reference group. Here, we named three simulated cell types as A, B, C, and use the cell type A, B as the reference cell types. 

```{r}
colnames(sim_count) = c("A", "B", "C")
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, reference = c("A", "B"))
```

Even though it is not recommended, DCATS allows the use of one cell type as the reference cell type. Especially when we are interested in the ratio relationship between two cell types (for eaxmple A and B).

```{r}
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, reference = c("A"))
```

When we have no idea which cell types can be used as reference cell types, DCATS supports detection of reference cell types automatically using the function `detect_reference`. This function returns a vector with ordered cell types and a meesage indicating how many cell types should be selected as the reference group. Cell types are ordered by an estimation of their proportion difference. The order indicating how they are recommended to be selected as reference cell types. We recommend to select top cell types.

Nonetheless, this kind of tasks is challenging and we suggest users perform the reference cell selection with caution.

```{r}
reference_cell = detect_reference(sim_count, sim_design, similarity_mat = simil_mat)
print(reference_cell)
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, reference = reference_cell$ordered_celltype[1:2])
```

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Haber2017}
\alias{Haber2017}
\title{Count matrices of intestinal epithelial scRNA-seq data from three conditions}
\format{
A list with 7 items:
\describe{
  \item{count_ctrl}{the count matrix for the control group}
  \item{count_Hpoly3}{the count matrix for three days after H.polygyrus infection}
  \item{count_Hpoly10}{the count matrix for ten days after H.polygyrus infection}
  \item{count_Salma}{the count matrix for two days after Salmonella infection}
  \item{svm_mat}{the similarity matrix}
  \item{source}{the source of this dataset}
}
}
\source{
\url{https://www.nature.com/articles/nature24489}
}
\usage{
Haber2017
}
\description{
A data containing the count matrices, the similarity matrix and other 
variables used to generate the similarity matrix from intestinal epithelial 
single cell RNA sequencing data with three condition. Count matrices are 
calculated based on the number of cells in each cell type. The similarity 
matrix is calculated by support vector machine classifiers using 5-fold 
cross validation. Top 30 PCs are used as predictors.
}
\examples{
library(DCATS)
data(Haber2017)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/detect_reference.R
\name{detect_reference}
\alias{detect_reference}
\title{Calculate a global phi for all cell types}
\usage{
detect_reference(count_mat, design_mat, similarity_mat = NULL, fix_phi = NULL)
}
\arguments{
\item{count_mat}{A matrix of composition sizes (n_sample, n_cluster) for each
cluster in each sample.}

\item{design_mat}{A matrix or a data frame of testing candidate factors 
(n_sample, n_factor) with same sample order as count_mat. All factors 
should be continous and categorical with only two levels.}

\item{similarity_mat}{A matrix of floats (n_cluster, n_cluster) for the
similarity matrix between cluster group pair. The order of cluster should
be consistent with those in `count_mat`.}

\item{fix_phi}{A numeric used to provided a fixed phi value for the GLM 
for all cell types.}
}
\value{
A data frame with ordered cell types and their p-value. Cell types 
are ordered by their p-values. The order indicating how they are recommended
to be selected as reference cell types.
}
\description{
Assuming all cell types share the same phi. This global phi can be calculate 
by pooling all cell types together to fit a beta binomial distribution.
}
\examples{
K <- 3
totals1 = c(100, 800, 1300, 600)
totals2 = c(250, 700, 1100)
diri_s1 = rep(1, K) * 20
diri_s2 = rep(1, K) * 20
simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"), 
gender = sample(c("Female", "Male"), 7, replace = TRUE))
## Using 1 factor vs NULL factor testing
detect_reference(sim_count, sim_design)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/knn_simMat.R
\name{knn_simMat}
\alias{knn_simMat}
\title{Calculate stochastic transition matrix between clusters from a KNN connection
matrix}
\usage{
knn_simMat(KNN_matrix, clusters)
}
\arguments{
\item{KNN_matrix}{a sparse binary matrix with size (n_sample, n_sample).
x_ij=1 means sample j is a neighbour of sample i. As definition, we expect
sum(KNN_matrix) = n_sample * K, where K is the number neighbours.}

\item{clusters}{a (n_sample, ) vector of cluster id for each sample.}
}
\value{
a similarity matrix calculated based on the knn graph.
}
\description{
The transition probability from cluster i to j is the fraction of neighbours
of all samples in cluster i that belongs to cluster j. Note, this matrix is
asymmetric, so as the input KNN connection matrix.
}
\examples{
data(simulation)
knn_mat = knn_simMat(simulation$knnGraphs, simulation$labels)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/svm_simMat.R
\name{svm_simMat}
\alias{svm_simMat}
\title{Calculate stochastic transition matrix between clusters from a data frame 
including information about clustering}
\usage{
svm_simMat(dataframe)
}
\arguments{
\item{dataframe}{a data frame contains the information used for clustering 
and the original label of each cell. The original labels should have the 
column name `clusterRes`.}
}
\value{
a similarity matrix estimated by 5-fold cross validation support 
vector machine.
}
\description{
The transition probability from cluster i to j is calculated based on the 
information used to cluster cells. It is estimated by the misclassification 
rate from cluster i to j comparing the original labels with the labels predicted 
by support vector machine with 5-fold cross validation.
}
\examples{
data(Kang2017)
svm_mat = svm_simMat(Kang2017$svmDF)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Ren2021}
\alias{Ren2021}
\title{Count matrix and metadata of a large COVID-19 scRNA-seq data cohort.}
\format{
A list with 7 items:
\describe{
  \item{countM}{the count matrix for all samples comming from different condition}
  \item{designM}{the corresponding metadata related to each sample}
  \item{source}{the source of this dataset}
}
}
\source{
\url{https://www.nature.com/articles/nature24489}
}
\usage{
Ren2021
}
\description{
A data containing the count matrix, metadata from a large COVID-19 cohort.
Count matrices are 
calculated based on the number of cells in each cell type. The information 
in the design matrix is collected in the original paper.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/create_simMat.R
\name{create_simMat}
\alias{create_simMat}
\title{Generate similarity matrix with uniform confusion rate to none-self clusters}
\usage{
create_simMat(K, confuse_rate)
}
\arguments{
\item{K}{A integer for number of cluster}

\item{confuse_rate}{A float for confusion rate, uniformly to none-self
clusters}
}
\value{
a similarity matrix with uniform confusion with other cluster
}
\description{
Create a similarity matrix assuming the misclassification error distribute
uniformly in all clusters
}
\examples{
create_simMat(4, 0.1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getPhi.R
\name{getPhi}
\alias{getPhi}
\title{Calculate a global phi for all cell types}
\usage{
getPhi(count_mat, design_mat)
}
\arguments{
\item{count_mat}{A matrix of composition sizes (n_sample, n_cluster) for each
cluster in each sample}

\item{design_mat}{A matrix of testing candidate factors (n_sample, n_factor)
with same sample order as count_mat}
}
\value{
A number indicating a global phi for all cell types
}
\description{
Assuming all cell types share the same phi. This global phi can be calculate 
by pooling all cell types together to fit a beta binomial distribution.
}
\examples{
K <- 3
totals1 = c(100, 800, 1300, 600)
totals2 = c(250, 700, 1100)
diri_s1 = rep(1, K) * 20
diri_s2 = rep(1, K) * 20
simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"))
phi = DCATS::getPhi(sim_count, sim_design)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulator_base.R
\name{simulator_base}
\alias{simulator_base}
\title{Composition size simulator}
\usage{
simulator_base(
  totals_cond1,
  totals_cond2,
  dirichlet_s1,
  dirichlet_s2,
  similarity_mat = NULL
)
}
\arguments{
\item{totals_cond1}{A vector of integers (n_rep1, ) for the total samples in
each replicate in codition 1}

\item{totals_cond2}{A vector of integers (n_rep2, ) for the total samples in
each replicate in codition 2}

\item{dirichlet_s1}{A vector of floats (n_cluster, ) for the composition
concentration in condition 1}

\item{dirichlet_s2}{A vector of floats (n_cluster, ) for the composition
concentration in condition 2}

\item{similarity_mat}{A matrix of floats (n_cluster, n_cluster) for the
similarity matrix between each cluster pair}
}
\value{
a list of two matrices for composition sizes in each replicate and
  each cluster in both conditions.
}
\description{
Directly simulating the composition size from a Dirichlet-Multinomial
distribution with replicates for two conditions.
}
\examples{
K <- 2
totals1 = c(100, 800, 1300, 600)
totals2 = c(250, 700, 1100)
diri_s1 = rep(1, K) * 20
diri_s2 = rep(1, K) * 20
confuse_rate = 0.2
simil_mat = create_simMat(2, 0.2)
sim_dat <- simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multinom_EM.R
\name{multinom_EM}
\alias{multinom_EM}
\title{An EM algorithm to fit a multinomial with maximum likelihood}
\usage{
multinom_EM(X, simMM, min_iter = 10, max_iter = 1000, logLik_threshold = 0.01)
}
\arguments{
\item{X}{A vector of commopent sizes}

\item{simMM}{A matrix of floats (n_cluster, n_cluster) for the similarity
matrix between clusters. simMM[i,j] means the proportion of cluster i will
be assigned to cluster j, hence colSums(simMM) are ones.}

\item{min_iter}{integer(1). number of minimum iterations}

\item{max_iter}{integer(1). number of maximum iterations}

\item{logLik_threshold}{A float. The threshold of logLikelihood increase for
detecting convergence}
}
\value{
a list containing \code{mu}, a vector for estimated latent proportion
  of each cluster, \code{logLik}, a float for the estimated log likelihood,
  \code{simMM}, the input of simMM, code{X}, the input of X, \code{X_prop},
  the proportion of clusters in the input X, \code{predict_X_prop}, and the
  predicted proportion of clusters based on mu and simMM.
}
\description{
An EM algorithm to fit a multinomial with maximum likelihood
}
\examples{
X = c(100, 300, 1500, 500, 1000)
simMM = create_simMat(5, confuse_rate=0.2)
multinom_EM(X, simMM)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dcats_GLM.R
\name{dcats_GLM}
\alias{dcats_GLM}
\title{A Generalised linear model based likelihood ratio testing}
\usage{
dcats_GLM(
  count_mat,
  design_mat,
  similarity_mat = NULL,
  pseudo_count = NULL,
  base_model = "NULL",
  fix_phi = NULL,
  reference = NULL
)
}
\arguments{
\item{count_mat}{A matrix of composition sizes (n_sample, n_cluster) for each
cluster in each sample}

\item{design_mat}{A matrix or a data frame of testing candidate factors 
(n_sample, n_factor) with same sample order as count_mat. All factors 
should be continous and categorical with only two levels.}

\item{similarity_mat}{A matrix of floats (n_cluster, n_cluster) for the
similarity matrix between cluster group pair. The order of cluster should
be consistent with those in `count_mat`.}

\item{pseudo_count}{A pseudo count to add for counts in all cell types
Default NULL means 0 except if a cell type is empty in one condition,
otherwise pseudo_count will be: 0.01 * rowMeans for each condition}

\item{base_model}{A string value: `NULL` for 1 factor vs NULL factor testing;
`FULL` for FULL factors vs n-1 factors testing.}

\item{fix_phi}{A numeric used to provided a fixed phi value for the GLM 
for all cell types}

\item{reference}{A vector of characters indicating which cell types are used 
as reference for normalization. `NULL` indicates using total count for 
normalization.}
}
\value{
a list of significance p values for each cluster
}
\description{
GLM supports both beta-binomial and negative binomial from aod package.
}
\examples{
K <- 3
totals1 = c(100, 800, 1300, 600)
totals2 = c(250, 700, 1100)
diri_s1 = rep(1, K) * 20
diri_s2 = rep(1, K) * 20
simil_mat = DCATS::create_simMat(K, confuse_rate=0.2)
sim_dat <- DCATS::simulator_base(totals1, totals2, diri_s1, diri_s2, simil_mat)
sim_count = rbind(sim_dat$numb_cond1, sim_dat$numb_cond2)
sim_design = data.frame(condition = c("g1", "g1", "g1", "g1", "g2", "g2", "g2"), 
gender = sample(c("Female", "Male"), 7, replace = TRUE))
## Using 1 factor vs NULL factor testing
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat)
## Using full factors vs n-1 factors testing with intercept term
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, base_model='FULL')
## Fix phi
dcats_GLM(sim_count, sim_design, similarity_mat = simil_mat, fix_phi = 1/61)
## Specify reference cell type
colnames(sim_count) <- c("celltypeA", "celltypeB", "celltypeC")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{simulation}
\alias{simulation}
\title{Simulated dataset with two conditions}
\format{
A list with 5 items:
\describe{
  \item{numb_cond1}{the count matrix of condition 1}
  \item{numb_cond2}{the count matrix of condition 2}
  \item{knn_mat}{the similariy matrix}
  \item{knnGraphs}{the knn graphs information used to calculate the 
  similarity matrix.}
  \item{labels}{the clusters' label for each simulated single cell}
}
}
\usage{
simulation
}
\description{
A data containing the count matrices, the similarity matrix and other 
variables used to generate the similarity matrix 
from a simulated single cell RNA sequencing data with two conditions. 
Dirichlet distribution was used to generate a proportion vector for cell 
types based on the defined true proportions. Multinomial distribution was 
used to generate simulated cell numbers. Cells were selected from cell pools
based on cell numbers and gene expression matrices were processed by Seurat.
The count matrix were calculated by the clustering results, and the 
similarity matrix was calculated using knn graph. The labels are the groud
true annotation of each cell.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Kang2017}
\alias{Kang2017}
\title{Count matrices of 8 pooled lupus patient samples within two conditions}
\format{
A list with 5 items:
\describe{
  \item{count_ctrl}{the count matrix for three days after H.polygyrus infection}
  \item{count_stim}{the count matrix for ten days after H.polygyrus infection}
  \item{svm_mat}{the simularity matrix}
  \item{svmDF}{the data frame used to calculate the similarity matrix.}
  \item{source}{the source of this dataset}
}
}
\source{
\url{https://www.nature.com/articles/nbt.4042}
}
\usage{
Kang2017
}
\description{
A data containing the count matrices, the similarity matrix and other 
variables used to generate the similarity matrix 
from single cell RNA sequencing data of 8 pooled lupus patient samples within 
two conditions. Count matrices are 
calculated based on the number of cells in each cell type. The similarity 
matrix is calculated by support vector machine classifiers using 5-fold 
cross validation. Top 30 PCs are used as predictors. The svmDF contains 30 
PCs generated by standard Seurat pipeline and the condition, cell type 
information collected from the original paper.
}
\keyword{datasets}
